<?php
// $Id: gvs.theme.inc,v 1.7 2010/06/29 11:37:07 btomic Exp $
/**
 * @file
 */

/**
 * Implementation of template_preprocess
 */

function template_preprocess_views_view_gvs(&$vars) {
  global $user;
  global $language;
// preprocess css information for the template
  $view = $vars['view'];
  $no_of_rows=count($view->result);

  $basetable=$view->base_table;
  $vars['divh']=$vars['options']['height'];
  $vars['divw']=$vars['options']['width'];
  $vars['emlink']=$vars['options']['emlink'];

  if ($vars['divh'] == '') $vars['divh']=200;
  if ($vars['divw'] == '') $vars['divw']=300;
  $pattern = "/^([0-9])+$/";
  if (!preg_match($pattern, $vars['divh'])) $vars['divh']=200;
  if (!preg_match($pattern, $vars['divw'])) $vars['divw']=300;

  // Width and height properties for API
  $csa=array();
  $csa['width']=$vars['options']['width'];
  $csa['height']=$vars['options']['height'];

  if ($vars['options']['title']!='')  $csa['title'] = $vars['options']['title'];
  // Make DIV instance
  $vars['gvs_id'] = 'gvs-'. $view->name  . '-'. $view->current_display;
  $vars['cwidth'] = $vars['options']['width'];
  $vars['cheight'] = $vars['options']['height'];

  // Color paletes for GeoMap and other charts
  $colorspie[1]=array('#1d73aa', '#c44441', '#8cbc4f', '#7a5892', '#009ab2', '#f48533', '#8baad1');
  $colorspie[2]=array('#003DF5', '#6633FF', '#CC33FF', '#FF33CC', '#3366FF', '#33CCFF', '#C3D9FF', '#002EB8', '#FF3366', '#33FFCC', '#B88A00', '#F5B800', '#FF6633', '#33FF66', '#66FF33', '#CCFF33', '#FFCC33');
  $colorspie[3]=array('#FFD300','#90FF00','#FF5F00','#3D00FF','#807540','#648040','#805740','#4F4080','#4D3F00','#2B4D00','#4D1C00','#12004D','#FFE980','#C8FF80','#FFAF80','#9E80FF','#FFFBE6','#F4FFE6','#FFEFE6','#ECE6FF');
  $colorspie[4]=array('#FF1A00', '#CC0000', '#FF7400', '#008C00', '#006E2E', '#4096EE', '#FF0084');
  $colorspie[5]=array('#B02B2C', '#D15600', '#C79810', '#73880A', '#6BBA70', '#3F4C6B', '#356AA0', '#D01F3C');
  $colorspie[6]=array('#d81f26', '#f15d51', '#f7a396', '#fde2db', '#dde9ec', '#88cadd', '#0092c2', '#144a90');
  $colorspie[7]=array('#ebebff','#000379');
  $colorspie[8]=array('#ffeef3','#8f0028');
  $colorspie[9]=array('#fce5ff','#b100c6');
  $colorspie[10]=array('#e3ffc7','#3d7c00');
  $colorspie[11]=array('#a12c21', '#e74d24', '#f37121', '#f6f5bc', '#f7f9e4', '#f89728', '#fec246', '#ffe38d');
  $colorspie[12]=array('#00fa2c', '#00dd25', '#00bf1f', '#00a06a', '#007d10', '#005908', '002e02', '#000d10');

  $colorsmap[1]=array(0x1d73aa, 0xc44441, 0x8cbc4f, 0x7a5892, 0x009ab2, 0xf48533, 0x8baad1);
  $colorsmap[2]=array(0x3366FF, 0x6633FF, 0xCC33FF, 0xFF33CC, 0x33CCFF, 0xC3D9FF, 0x003DF5, 0x002EB8, 0xFF3366, 0x33FFCC, 0xB88A00, 0xF5B800, 0xFF6633, 0x33FF66, 0x66FF33, 0xCCFF33, 0xFFCC33);
  $colorsmap[3]=array(0xFFD300,0x90FF00,0xFF5F00,0x3D00FF,0x807540,0x648040,0x805740,0x4F4080,0x4D3F00,0x2B4D00,0x4D1C00,0x12004D,0xFFE980,0xC8FF80,0xFFAF80,0x9E80FF,0xFFFBE6,0xF4FFE6,0xFFEFE6,0xECE6FF);
  $colorsmap[4]=array(0xFF1A00, 0xCC0000, 0xFF7400, 0x008C00, 0x006E2E, 0x4096EE, 0xFF0084);
  $colorsmap[5]=array(0xB02B2C, 0xD15600, 0xC79810, 0x73880A, 0x6BBA70, 0x3F4C6B, 0x356AA0, 0xD01F3C);
  $colorsmap[6]=array(0xd81f26, 0xf15d51, 0xf7a396, 0xfde2db, 0xdde9ec, 0x88cadd, 0x0092c2, 0x144a90);
  $colorsmap[7]=array(0xebebff,0x000379);
  $colorsmap[8]=array(0xffeef3,0x8f0028);
  $colorsmap[9]=array(0xfce5ff,0xb100c6);
  $colorsmap[10]=array(0xe3ffc7,0x3d7c00);
  $colorsmap[11]=array(0xa12c21, 0xffe38d);
  $colorsmap[12]=array(0x00fa2c, 0x000d10);


  // Generate appropriate js code for different type of charts
  switch ($vars['options']['type']) {
    case '0':
      // PieChart
      $constructor='PieChart';
      if ($vars['options']['is3D'])
        $csa ['is3D'] =  true;
      else
        $csa ['is3D'] = false;
      if ($vars['options']['pieJoinAngle'] !='') $csa['pieJoinAngle'] = $vars['options']['pieJoinAngle'];
      if ($vars['options']['pieMinimalAngle'] !='') $csa['pieMinimalAngle'] = $vars['options']['pieMinimalAngle'];
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorspie[$vars['options']['color']];
	  
      $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis1']]['label'] . "');
                data.addRows(" . $no_of_rows . ");";
      $xfield=$view->field[$vars['options']['xaxis']]->field;
      $yfield=$view->field[$vars['options']['yaxis1']]->field;
      for ($j=0;$j<$no_of_rows;$j++) {
        $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$xvalue) . "'") . ");";
        $strdata .= "data.setValue(" . $j . ", 1, " . (is_null($yvalue)?'undefined':$yvalue) . ");";
      }
      break;
    case '1':
      // Gauge
      $constructor='Gauge';

	  if ($vars['options']['greenFrom'] !='') $csa['greenFrom'] =$vars['options']['greenFrom'];
	  if ($vars['options']['greenTo'] !='') $csa['greenTo'] = $vars['options']['greenTo'];
	  if ($vars['options']['yellowFrom'] !='') $csa['yellowFrom'] = $vars['options']['yellowFrom'];
	  if ($vars['options']['yellowTo'] !='') $csa['yellowTo'] = $vars['options']['yellowTo'];
	  if ($vars['options']['redFrom'] !='') $csa['redFrom'] = $vars['options']['redFrom'];
	  if ($vars['options']['redTo'] !='') $csa['redTo'] = $vars['options']['redTo'];
	  if ($vars['options']['GaugeMin'] !='') $csa['min'] = $vars['options']['GaugeMin'];
	  if ($vars['options']['GaugeMax'] !='') $csa['max'] = $vars['options']['GaugeMax'];

      $strdata="data.addColumn('string','" .  $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis1']]['label'] . "');
                data.addRows(" . $no_of_rows . ");";
      $xfield=$view->field[$vars['options']['xaxis']]->field;
      $yfield=$view->field[$vars['options']['yaxis1']]->field;
      for ($j=0;$j<$no_of_rows;$j++) {
        $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$xvalue) . "'") . ");";
        $strdata .= "data.setValue(" . $j . ", 1, " . (is_null($yvalue)?'undefined':$yvalue) . ");";
      }
      break;
    case '2':
      // BarChart
      $constructor='BarChart';
      if ($vars['options']['is3D'])
        $csa ['is3D'] =  true;
      else
        $csa ['is3D'] = false;
      if ($vars['options']['linlog']=='log') $csa ['logScale'] = true;
      if ($vars['options']['isStacked']) $csa ['isStacked'] = true;
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorspie[$vars['options']['color']];
	  
      $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
      for ($jj=1; $jj<6; $jj++) {
        if ($vars['options']['yaxis' . $jj] != '')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0; $j<$no_of_rows; $j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field;
        $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $strdata .= "data.setValue(" . $j . ", 0, " . ( is_null($xvalue) ? 'undefined' : "'" .  str_replace("'","\'",$xvalue) . "'" ) . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ( $vars['options']['yaxis' . $jj] != '' ) {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field;
            $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '3':
      // AreaChart
      $constructor='AreaChart';
      if ($vars['options']['linlog']=='log') $csa ['logScale'] = true;
      if ($vars['options']['isStacked']) $csa ['isStacked'] = true;
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorspie[$vars['options']['color']];
	  
      $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field;
        $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$xvalue) . "'") . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field;
            $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '4':
      // ColumnChart
      $constructor='ColumnChart';
      if ($vars['options']['is3D'])
        $csa ['is3D'] =  true;
      else
        $csa ['is3D'] = false;
      if ($vars['options']['linlog']=='log') $csa ['logScale'] = true;
      if ($vars['options']['isStacked']) $csa ['isStacked'] = true;
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorspie[$vars['options']['color']];

      $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field;
		$xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$xvalue) . "'") . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field;
            $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '5':
      // LineChart
      $constructor='LineChart';
      if ($vars['options']['linlog']=='log') $csa['logScale'] = true;
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorspie[$vars['options']['color']];

      $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field;
        $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$xvalue) . "'") . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field;
            $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '6':
      // ScatterChart
      $constructor='ScatterChart';
      if ($vars['options']['linlog']=='log') $csa['logScale'] = true;
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorspie[$vars['options']['color']];

      $strdata="data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis1']]['label'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis1']]->field;
        $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':$xvalue) . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field;
            $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '7':
      // GeoMap
      $constructor='GeoMap';
	  $csa['region'] = $vars['options']['region1']; $csa['dataMode'] = $vars['options']['geomaptype'];
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorsmap[$vars['options']['color']];

      $no_of_cols=array();
      if ($vars['options']['geomaptype']=='region') {
        $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['geomapstring']]['label'] . "');";
        $no_of_cols[]='geomapstring';
        if ($vars['options']['yaxis1']!='') {
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis1']]['label'] . "');";
          $no_of_cols[]='yaxis1';
        }
        if ($vars['options']['xaxis']!='') {
          $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
          $no_of_cols[]='xaxis';
        }
      }
      else {
        if ($vars['options']['geomaplat']!='' && $vars['options']['geomaplon']!='') {
          $strdata="data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['geomaplat']]['label'] . "');";
          $no_of_cols[]='geomaplat';
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['geomaplon']]['label'] . "');";
          $no_of_cols[]='geomaplon';
          if ($vars['options']['yaxis1']!='') {
            $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis1']]['label'] . "');";
            $no_of_cols[]='yaxis1';
          }
          if ($vars['options']['xaxis']!='') {
            $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
            $no_of_cols[]='xaxis';
          }
        }
        else {
          if ($vars['options']['geomapstring']!='') {
            $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['geomapstring']]['label'] . "');";
            $no_of_cols[]='geomapstring';
            if ($vars['options']['yaxis1']!='') {
              $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis1']]['label'] . "');";
              $no_of_cols[]='yaxis1';
            }
            if ($vars['options']['xaxis']!='') {
              $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
              $no_of_cols[]='xaxis';
            }
          }
          else
            $strdata='Error';
        }
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++)
        for ($jj=0;$jj<count($no_of_cols);$jj++) {
          $xfield=$view->field[$vars['options'][$no_of_cols[$jj]]]->field;
          $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];

          if ($no_of_cols[$jj]=='yaxis1' || $no_of_cols[$jj]=='geomaplat' || $no_of_cols[$jj]=='geomaplon')
            $strdata .= "data.setValue(" . $j . "," . $jj . "," . (is_null($xvalue)?'undefined':$xvalue) . ");";
          else {
            if ($no_of_cols[$jj]=='xaxis') $xvalue=strtoupper($xvalue);
            $strdata .= "data.setValue(" . $j . "," . $jj . "," . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$xvalue) . "'") . ");";
          }
        }
      break;
    case '8':
      // Intensity Map
      $constructor='IntensityMap';
	  $csa['region'] = $vars['options']['region'];
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorspie[$vars['options']['color']];

      $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field;
        $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" . str_replace("'","\'",$xvalue) . "'") . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field;
            $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '9':
      // Motion Chart
	  if ($vars['options']['showChartButtons'])  $csa['showChartButtons'] = true; else $csa['showChartButtons'] = false;
	  if ($vars['options']['showHeader']) $csa['showHeader'] = true; else $csa['showHeader'] = false;
	  if ($vars['options']['showSelectListComponent']) $csa['showSelectListComponent'] = true; else $csa['showSelectListComponent'] = false;
	  if ($vars['options']['showSidePanel']) $csa['showSidePanel'] = true; else $csa['showSidePanel'] = false;
	  if ($vars['options']['showXMetricPicker']) $csa['showXMetricPicker'] = true; else $csa['showXMetricPicker'] = false;
	  if ($vars['options']['showYMetricPicker']) $csa['showYMetricPicker'] = true; else $csa['showYMetricPicker'] = false;
	  if ($vars['options']['showXScalePicker']) $csa['showXScalePicker'] = true; else $csa['showXScalePicker'] = false;
	  if ($vars['options']['showYScalePicker']) $csa['showYScalePicker'] = true; else $csa['showYScalePicker'] = false;
	  if ($vars['options']['showAdvancedPanel']) $csa['showAdvancedPanel'] = true; else $csa['showAdvancedPanel'] = false;
      if ($vars['options']['state'] !='') $csa['state'] = "'".$vars['options']['state']."'";

      $constructor='MotionChart';
      $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
      if ($vars['options']['mcdateformat'] == '1')
		$strdata .= "data.addColumn('date','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis11']]['label'] . "');";
	  elseif ($vars['options']['mcdateformat'] == '2')
		$strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis11']]['label'] . "');";
	  else
		$strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis11']]['label'] . "');";
      for ($jj=2;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
      }
      for ($jj=2;$jj<6;$jj++) {
        if ($vars['options']['zaxis' . $jj]!='')
          $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['zaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
        $xvalue=$view->result[$j]->$xfield;
        $yfield=$view->field[$vars['options']['yaxis11']]->field_alias;
        $yvalue=$view->result[$j]->$yfield;
        $strdata .= "data.setValue(" . $j . ", 0," . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$xvalue) . "'") . ");";

        if (is_null($yvalue))
          $strdata .= "data.setValue(" . $j . ", 1, undefined);";
        else {
			switch ($vars['options']['mcdateformat']){
				case '1':
					$yvaluedate = strtotime($yvalue);
					if ($yvaluedate === FALSE)
						$strdata .= "data.setValue(" . $j . ", 1, undefined);";
					else
						$strdata .= "data.setValue(" . $j . ", 1, new Date (" . date('Y', $yvaluedate) . "," . (date('m', $yvaluedate)-1) . "," . date('d', $yvaluedate) . "));";
				break;
				case '2':
					$yvaluedate = strtotime($yvalue);
					if ($yvaluedate === FALSE)
						$strdata .= "data.setValue(" . $j . ", 1, undefined);";
					else
						$strdata .= "data.setValue(" . $j . ", 1,". date('Y', $yvaluedate) .");";
					break;
				case '3':
					$yvaluedate = strtotime($yvalue);
					if ($yvaluedate === FALSE)
						$strdata .= "data.setValue(" . $j . ", 1, undefined);";
					else
						$strdata .= "data.setValue(" . $j . ", 1,'". date('Y', $yvaluedate)."W".date('W', $yvaluedate)."');";
					break;
				case '4':
					if (preg_match("/^(\d{4})Q(\d{1})$/", $yvalue,$aaa)){
						$yvaluedate = strtotime($aaa[1]."W".($aaa[2]-1)*15+1);
						$strdata .= "data.setValue(" . $j . ", 1,'". date('Y', $yvaluedate)."Q".((int)floor(date('m', $yvaluedate)/3.1)+1)."');";
					} else {
						$yvaluedate = strtotime($yvalue);
						if ($yvaluedate === FALSE)
							$strdata .= "data.setValue(" . $j . ", 1, undefined);";
						else
							$strdata .= "data.setValue(" . $j . ", 1,'". date('Y', $yvaluedate)."Q".((int)floor(date('m', $yvaluedate)/3.1)+1)."');";
					}
					break;
			}
        }

        $jjj=2;
        for ($jj=2;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
        for ($jj=2;$jj<6;$jj++) {
          if ($vars['options']['zaxis' . $jj]!='') {
            $zfield=$view->field[$vars['options']['zaxis' . $jj]]->field_alias;
            $zvalue=$view->result[$j]->$zfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($zvalue)?'undefined':"'" .  str_replace("'","\'",$zvalue) . "'") . ");";
            $jjj++;
          }
        }
      }
      break;
    case '10':
      $constructor='AnnotatedTimeLine';

      if ($vars['options']['displayAnnotations']) $csa['displayAnnotations'] = true ; else $csa['displayAnnotations'] = false;
	  if ($vars['options']['displayAnnotationsFilter']) $csa['displayAnnotationsFilter'] = true ; else $csa['displayAnnotationsFilter'] = false;
	  if ($vars['options']['displayDateBarSeparator']) $csa['displayDateBarSeparator'] = true ; else $csa['displayDateBarSeparator'] = false;
	  if ($vars['options']['displayExactValues']) $csa['displayExactValues'] = true ; else $csa['displayExactValues'] = false;
      if ($vars['options']['displayLegendDots']) $csa['displayLegendDots'] = true ; else $csa['displayLegendDots'] = false;
      if ($vars['options']['displayRangeSelector']) $csa['displayRangeSelector'] = true ; else $csa['displayRangeSelector'] = false;
      if ($vars['options']['displayZoomButtons']) $csa['displayZoomButtons'] = true ; else $csa['displayZoomButtons'] = false;
	  if ($vars['options']['atlmin']!='') $csa['min'] = $vars['options']['atlmin'];
	  if ($vars['options']['atlmax']!='') $csa['max'] = $vars['options']['atlmax'];
	  if ($vars['options']['atlfill']!='') $csa['atlfill'] = $vars['options']['atlmax'];else $csa['atlfill'] = 0;
	  if ($vars['options']['atlthickness']!='') $csa['atlthickness'] = $vars['options']['atlmax'];else $csa['atlthickness'] = 0;
	  if ($vars['options']['scaleColumns']=='0'){
		if ($vars['options']['scaleType']!='fixed') $csa['scaleType'] = 'maximized'; else $csa['scaleType']='fixed';
	  }
	  else {
		if ($vars['options']['scaleType']!='fixed') $csa['scaleType'] = 'allmaximized'; else $csa['scaleType']='allfixed';
		if ($vars['options']['scaleColumns']=='1')
			$csa['scaleColumns']=array(0,1);
		else
			$csa['scaleColumns']=array(0,1,2);
	  }
	  if ($vars['options']['color']!='0') $csa ['colors'] = $colorspie[$vars['options']['color']];
	  
      $strdata = "data.addColumn('date','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis11']]['label'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
		if ($vars['options']['zaxis' . $jj]!='')
          $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['zaxis' . $jj]]['label'] . "');";
		if ($vars['options']['zzaxis' . $jj]!='')
          $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['zzaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $yfield=$view->field[$vars['options']['yaxis11']]->field_alias;
        $yvalue=$view->result[$j]->$yfield;
        if (is_null($yvalue))
          $strdata .= "data.setValue(" . $j . ", 0, undefined);";
        else {
			$yvaluedate = strtotime($yvalue);
			if ($yvaluedate === FALSE)
				$strdata .= "data.setValue(" . $j . ", 0, undefined);";
			else {
				$strdata .= "data.setValue(" . $j . ", 0, new Date (" .date('Y', $yvaluedate) . "," . (date('m', $yvaluedate)-1) . "," . date('d', $yvaluedate) . "));";
			}
        }
        $jjj=1;
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
			$yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
		  if ($vars['options']['zaxis' . $jj]!='') {
            $zfield=$view->field[$vars['options']['zaxis' . $jj]]->field_alias;
            $zvalue=$view->result[$j]->$zfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($zvalue)?'undefined':"'" .  str_replace("'","\'",$zvalue) . "'") . ");";
            $jjj++;
          }
		  if ($vars['options']['zzaxis' . $jj]!='') {
            $zzfield=$view->field[$vars['options']['zzaxis' . $jj]]->field_alias;
            $zzvalue=$view->result[$j]->$zfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($zzvalue)?'undefined':"'" .  str_replace("'","\'",$zzvalue) . "'") . ");";
            $jjj++;
          }
        }
      }
      break;
    case '11':
      $constructor='Map';

	  $csa['mapType']=$vars['options']['maptype'];

      $strdata  = "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['geomaplat1']]['label'] . "');";
      $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['geomaplon1']]['label'] . "');";
      $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['geomapstring']]['label'] . "');";
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $field=$view->field[$vars['options']['geomaplat1']]->field_alias;
        $value=$view->result[$j]->$field;
        $strdata .= "data.setValue(" . $j . ",0," . (is_null($value)?'undefined':$value) . ");";
        $field=$view->field[$vars['options']['geomaplon1']]->field_alias;
        $value=$view->result[$j]->$field;
        $strdata .= "data.setValue(" . $j . ",1," . (is_null($value)?'undefined':$value) . ");";
        $field=$view->field[$vars['options']['geomapstring']]->field_alias;
        $value=$view->result[$j]->$field;
        $strdata .= "data.setValue(" . $j . ",2," . (is_null($value)?'undefined':"'" . str_replace("'","\'",$value) . "'") . ");";
      }
      break;
    case '14':
      $constructor='Table';
	  $csa['page']=$vars['options']['page'];
	  $csa['pageSize']=$vars['options']['pageSize'];
	  if ($vars['options']['showRowNumber']) $csa['showRowNumber'] = true ; else $csa['showRowNumber'] = false;

      $strdata = "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['xaxis']]['label'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis' . $jj]]['label'] . "');";
		if ($vars['options']['zaxis' . $jj]!='')
          $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['zaxis' . $jj]]['label'] . "');";
		if ($vars['options']['zzaxis' . $jj]!='')
          $strdata .= "data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['zzaxis' . $jj]]['label'] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $yfield=$view->field[$vars['options']['xaxis']]->field_alias;
        $yvalue=$view->result[$j]->$yfield;
		$strdata .= "data.setValue(" . $j . ", 0, " . (is_null($yvalue)?'undefined':"'" .  str_replace("'","\'",$yvalue) . "'") . ");";
        $jjj=1;
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
			$yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
		  if ($vars['options']['zaxis' . $jj]!='') {
            $zfield=$view->field[$vars['options']['zaxis' . $jj]]->field_alias;
            $zvalue=$view->result[$j]->$zfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($zvalue)?'undefined':"'" .  str_replace("'","\'",$zvalue) . "'") . ");";
            $jjj++;
          }
		  if ($vars['options']['zzaxis' . $jj]!='') {
            $zzfield=$view->field[$vars['options']['zzaxis' . $jj]]->field_alias;
            $zzvalue=$view->result[$j]->$zfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($zzvalue)?'undefined':"'" .  str_replace("'","\'",$zzvalue) . "'") . ");";
            $jjj++;
          }
        }
      }
      break;
	case '15':
      // Treemap
      $constructor='TreeMap';
	  /*
      if ($vars['options']['is3D'])
        $csa ['is3D'] =  true;
      else
        $csa ['is3D'] = false;
      if ($vars['options']['pieJoinAngle'] !='') $csa['pieJoinAngle'] = $vars['options']['pieJoinAngle'];
      if ($vars['options']['pieMinimalAngle'] !='') $csa['pieMinimalAngle'] = $vars['options']['pieMinimalAngle'];
*/
      $strdata="data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['zaxis1']]['label'] . "');
	            data.addColumn('string','" . $view->style_plugin->display->display_options['fields'][$vars['options']['zzaxis1']]['label'] . "');
				data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis1']]['label'] . "');";
      $xfield=$view->field[$vars['options']['zaxis1']]->field;
      $yfield=$view->field[$vars['options']['zzaxis1']]->field;
	  $yfield1=$view->field[$vars['options']['yaxis1']]->field;
	  if ($vars['options']['yaxis2']!=''){
		$strdata .= "data.addColumn('number','" . $view->style_plugin->display->display_options['fields'][$vars['options']['yaxis2']]['label'] . "');";
		$yfield2=$view->field[$vars['options']['yaxis2']]->field;
	  }
	  $strdata.="data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $xvalue=$view->style_plugin->rendered_fields[$j][$xfield];
        $yvalue=$view->style_plugin->rendered_fields[$j][$yfield];
		$y1value=$view->style_plugin->rendered_fields[$j][$yfield1];
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$xvalue) . "'") . ");";
		$strdata .= "data.setValue(" . $j . ", 1, " . (is_null($xvalue)?'undefined':"'" .  str_replace("'","\'",$yvalue) . "'") . ");";
        $strdata .= "data.setValue(" . $j . ", 2, " . (is_null($yvalue)?'undefined':$y1value) . ");";
		if ($vars['options']['yaxis2']!=''){
			$y2value=$view->style_plugin->rendered_fields[$j][$yfield2];
			$strdata .= "data.setValue(" . $j . ", 3, " . (is_null($yvalue)?'undefined':$y2value) . ");";
		}
      }
      break;
  }

//Additional settings
  if (in_array($vars['options']['type'], array(0, 2, 3, 4, 5, 6))){
    if ($vars['options']['legendBackgroundColor'] !='') $csa['legendBackgroundColor'] = $vars['options']['legendBackgroundColor'];
    if ($vars['options']['legendFontSize'] !='')  $csa['legendFontSize'] = $vars['options']['legendFontSize'];
    if ($vars['options']['legendTextColor'] !='') $csa['legendTextColor'] = $vars['options']['legendTextColor'];
    if ($vars['options']['backgroundColor'] !='') $csa['backgroundColor'] = $vars['options']['backgroundColor'];
    if ($vars['options']['borderColor'] !='') $csa['borderColor'] =$vars['options']['borderColor'];
    if ($vars['options']['titleColor'] !='') $csa['titleColor']=$vars['options']['titleColor'];
    if ($vars['options']['titleFontSize'] !='') $csa['titleFontSize'] = $vars['options']['titleFontSize'];
    if ($vars['options']['axisColor'] !='') $csa['axisColor']=$vars['options']['axisColor'];
    if ($vars['options']['axisBackgroundColor'] !='') $csa['axisBackgroundColor']=$vars['options']['axisBackgroundColor'];
    if ($vars['options']['axisFontSize'] !='') $csa['axisFontSize']=$vars['options']['axisFontSize'];
    $csa['legend'] = $vars['options']['legend'];
    if ($vars['options']['enableTooltip'] == '1') $csa['enableTooltip'] = true; else $csa['enableTooltip'] = false;
  }
  if (in_array($vars['options']['type'], array(2, 3, 4, 5, 6))){
    if ($vars['options']['titleX'] !='') $csa['titleX'] = $vars['options']['titleX'];
    if ($vars['options']['titleY'] !='') $csa['titleY'] = $vars['options']['titleY'];
   }

  // Generate some necessary js code for Google Viz API
  $typepackages=strtolower($constructor);
  $api_key = variable_get('dv_api_key', False);

  if (($vars['options']['type']=='7' && $vars['options']['geomaptype']=='markers') || ($vars['options']['type']=='11'))
    if ($api_key) {
      $gvs_gmap_gapi="http://maps.google.com/maps?file=api&v=2&key=" . $api_key;
      drupal_set_html_head('<script type="text/javascript" src="'. $gvs_gmap_gapi  . '"></script>');
    }
    else
      drupal_set_message('Enter Google maps key in Gmap settings','error');

  if ($vars['options']['type']=='11')
    if ($api_key) {
      $gvs_gmap_gapi="http://maps.google.com/maps?file=api&v=2&key=" . $api_key;
      drupal_set_html_head('<script type="text/javascript" src="'. $gvs_gmap_gapi  . '"></script>');
    }
    else
      drupal_set_message('Enter Google maps key in Gmap settings','error');

  if ($vars['options']['type']!='13') {
    $gvs_gapi="http://www.google.com/jsapi";
    drupal_set_html_head('<script type="text/javascript" src="'. $gvs_gapi  . '"></script>');
    if ($vars['options']['type']!='12')
      drupal_set_html_head("<script type=\"text/javascript\">google.load('visualization', '1', {'packages':['" . $typepackages . "'], 'language': '" . $language->language . "'});</script>");
    $inlinet="function drawChart(){var data = new google.visualization.DataTable();var chart;";
    $inlinet .= $strdata;
    $inlinet .= "chart = new google.visualization." . $constructor . "(document.getElementById('" . $vars['gvs_id'] . "'));
                 chart.draw(data, " . json_encode($csa) . ");}
                 google.setOnLoadCallback(drawChart);";
  }
  else {
    if ($api_key) {
      $gvs_gmap_gapi="http://www.google.com/jsapi?key=" . $api_key;
      drupal_set_html_head('<script type="text/javascript" src="'. $gvs_gmap_gapi  . '"></script>');
    }
    else
      drupal_set_message('Enter Google maps key in Gmap settings','error');
    $inlinet='google.load("earth", "1");var ge = null;function init(){google.earth.createInstance("' . $vars['gvs_id'] . '", initCallback, failureCallback)};
              function initCallback(object){ge = object;ge.getWindow().setVisibility(true);ge.getNavigationControl().setVisibility(ge.VISIBILITY_AUTO);}
              function failureCallback(object) {}
              google.setOnLoadCallback(init);';
  }
  // Add code to template
  drupal_add_js($inlinet, 'inline');

  // Make file for embeding
  if ($vars['emlink'] && $user->uid != 0 && user_access('see embeding link')){
	$filestring ='<html><head>';
	if (($vars['options']['type']=='7' && $vars['options']['geomaptype']=='markers') || ($vars['options']['type']=='11') || ($vars['options']['type']=='13'))
	  $filestring.='<script type="text/javascript" src="'. $gvs_gmap_gapi.'"></script>';
	$filestring.='<script type="text/javascript" src="'. $gvs_gapi  .'"></script>';
	if ($vars['options']['type']!='12')
      $filestring.="<script type=\"text/javascript\">google.load('visualization','1',{'packages':['" . $typepackages . "']});</script>";
    $filestring.='<script type="text/javascript">'. $inlinet .'</script>';
    $filestring.='</head><body>';
    $filestring.='<div id="'.$vars['gvs_id'].'" style="text-align:center;height:'.$vars['divh'].'px;width:'.$vars['divw'].'px;"></div>';
    $filestring.='</body></html>';
    $directory = file_directory_path() . '/gvs_embed/' . $user->uid;
    file_check_directory($directory, TRUE);
    $directory = file_directory_path() . '/gvs_embed/' . $user->uid . '/permanent';
    file_check_directory($directory, TRUE);
    if ($vars['options']['emlinkforever']){
       $dest=file_directory_path().'/gvs_embed/' . $user->uid . '/permanent/' . $view->name.'_'.$view->current_display.($view->args[0]?"_".$view->args[0]:"").'.html';
       $dest_path = file_directory_path().'/gvs_embed/' . $user->uid . '/permanent';
    }
    else{
	   $dest=file_directory_path().'/gvs_embed/' . $user->uid . '/' . $view->name.'_'.$view->current_display.($view->args[0]?"_".$view->args[0]:"").'.html';
       $dest_path = file_directory_path().'/gvs_embed/' . $user->uid;
    }
    $vars['embed_file_dest'] = $dest;
    $vars['embed_file_basename'] = $view->name.'_'.$view->current_display.($view->args[0]?"_".$view->args[0]:"").'.html';;
    $vars['embed_file_destpath'] = $dest_path;
    $vars['embed_file_filestring'] = $filestring;
  }

}

/**
 * Overridable theme function.
 * This functions prints a warning when no data is available.
 */
function theme_gvs_nodata() {
  drupal_set_message(t('There is no data available'), 'warning');
}
